require({cache:{
'url:dijit/form/templates/Select.html':"<table class=\"dijit dijitReset dijitInline dijitLeft\"\n\tdata-dojo-attach-point=\"_buttonNode,tableNode,focusNode\" cellspacing='0' cellpadding='0'\n\trole=\"listbox\" aria-haspopup=\"true\"\n\t><tbody role=\"presentation\"><tr role=\"presentation\"\n\t\t><td class=\"dijitReset dijitStretch dijitButtonContents\" role=\"presentation\"\n\t\t\t><div class=\"dijitReset dijitInputField dijitButtonText\"  data-dojo-attach-point=\"containerNode,_popupStateNode\" role=\"presentation\"></div\n\t\t\t><div class=\"dijitReset dijitValidationContainer\"\n\t\t\t\t><input class=\"dijitReset dijitInputField dijitValidationIcon dijitValidationInner\" value=\"&#935; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t/></div\n\t\t\t><input type=\"hidden\" ${!nameAttrSetting} data-dojo-attach-point=\"valueNode\" value=\"${value}\" aria-hidden=\"true\"\n\t\t/></td\n\t\t><td class=\"dijitReset dijitRight dijitButtonNode dijitArrowButton dijitDownArrowButton dijitArrowButtonContainer\"\n\t\t\tdata-dojo-attach-point=\"titleNode\" role=\"presentation\"\n\t\t\t><input class=\"dijitReset dijitInputField dijitArrowButtonInner\" value=\"&#9660; \" type=\"text\" tabIndex=\"-1\" readonly=\"readonly\" role=\"presentation\"\n\t\t\t\t${_buttonInputDisabled}\n\t\t/></td\n\t></tr></tbody\n></table>\n"}});
define("epi-cms/project/ProjectSelector", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/has",
    "dojo/when",
    "epi",
    // Resources
    "dojo/text!dijit/form/templates/Select.html",
    // Grid
    "dgrid/OnDemandList",
    "dgrid/Selection",
    "dgrid/Keyboard",
    "epi/shell/dgrid/Focusable",
    // Parent class and mixins
    "dijit/form/_FormValueWidget",
    "epi/shell/widget/_HasDeferredDropDown"
], function(
    declare,
    lang,
    domConstruct,
    has,
    when,
    epi,
    // Resources
    template,
    // Grid
    List,
    Selection,
    Keyboard,
    Focusable,
    // Parent class and mixins
    _FormValueWidget,
    _HasDeferredDropDown
) {

    return declare([_FormValueWidget, _HasDeferredDropDown], {

        // baseClass: [protected] String
        //      Root CSS class of the widget, used to construct CSS classes to indicate widget state.
        baseClass: "dijitSelect dijitValidationTextBox",

        // templateString: [protected] String
        //      A string that represents the widget template.
        templateString: template,

        // loadEvent: [readonly] String
        //      The event that the drop down will raise when it has finished loading.
        loadEvent: "dgrid-refresh-complete",

        // store: [public] Store
        //      A store to query for the list of options.
        store: null,

        // query: [public] Object
        //      A query to use when fetching items from the store.
        query: null,

        // totalProjects: [readonly] int
        //      Current projects count.
        totalProjects: null,

        // _buttonInputDisabled: [private] String
        //      Required by the template. It allows IE to disallow focus, but Firefox cannot be disabled for mousedown events.
        _buttonInputDisabled: has("ie") ? "disabled" : "",

        buildRendering: function() {
            this.inherited(arguments);

            // We need to create the display node since the template doesn't include it.
            this.displayNode = domConstruct.create("span", { role: "option", "class": "dijitReset dijitInline dijitSelectLabel" }, this.containerNode);

            this.dropDown = new (declare([List, Selection, Keyboard, Focusable]))({
                className: "epi-grid-select epi-grid-select--min-width epi-focused",
                cleanEmptyObservers: false,
                deselectOnRefresh: false,
                selectionMode: "single",
                selectionEvents: "click",
                store: this.store,
                query: this.get("query"),
                renderRow: lang.hitch(this, "renderItem")
            });

            this.own(
                this.dropDown.on("dgrid-select", lang.hitch(this, "onItemSelected")),
                this.dropDown.on("dgrid-refresh-complete", lang.hitch(this, "onSelectUpdated"))
                );
        },

        compare: function(value1, value2) {
            // summary:
            //      Compare two values (as returned by get("value") for this widget).
            // tags:
            //      protected
            return epi.areEqual(value1, value2) ? 0 : -1;
        },

        destroy: function(){
            // summary:
            //      Destroy this class, releasing any resources registered.
            // tags:
            //      protected
            if (this.dropDown) {
                // Override the _HasDropDown destroy logic since that calls destroyRecursive which is
                // undefined on the dgrid.
                if (!this.dropDown._destroyed) {
                    this.dropDown.destroy();
                }
                delete this.dropDown;
            }
            this.inherited(arguments);
        },

        onItemSelected: function(e) {
            // summary:
            //      Callback that executes when an item is selected in the drop down.
            // tags:
            //      protected

            // Get the first item since it is single selection.
            this.set("value", e.rows[0].data);

            this.closeDropDown(true);
        },

        onSelectUpdated: function(evt) {
            // summary:
            //      Callback that executes when the dropdown list has been updated
            // tags:
            //      protected
            when(evt.results.total, lang.hitch(this, function(total) {
                this.set("totalProjects", total);
            }));
        },

        openDropDown: function() {
            // summary:
            //      Opens the drop down and refreshes its contents.
            // tags:
            //      protected
            this.dropDown.refresh();
            this.inherited(arguments);
        },

        renderItem: function(value) {
            // summary:
            //      Renders the item in the list as a DOM node.
            // tags:
            //      protected
            var node = domConstruct.create("div"),
                text = document.createTextNode(value.name);

            domConstruct.place(text, node);
            return node;
        },

        _getQueryAttr: function() {
            return this.query || {};
        },

        _setQueryAttr: function(query) {
            this._set("query", query);
            if (this.dropDown) {
                this.dropDown.set("query", this.get("query"));
            }
        },

        _setStoreAttr: function(store) {
            this._set("store", store);
            if (this.dropDown) {
                this.dropDown.set("store", store);
            }
        },

        _setValueAttr: function(value) {
            var displayName;

            if (this.compare(value, this.value) !== 0) {

                this.inherited(arguments);

                displayName = value && value.name ? value.name : "";
                this.set("title", displayName);
                this.displayNode.textContent = displayName;

                // Clear the value regardless if there is a value or not. This ensures we don't
                // have multiple items selected.
                this.dropDown.clearSelection();
                if (value) {
                    this.dropDown.select(value.id);
                }
            }
        }
    });
});
