define("epi-cms/project/command/RemoveProjectItem", [
    "dojo/_base/declare",

// Parent class
    "./_ProjectCommand",
     "epi-cms/contentediting/ContentActionSupport",

// Resources
    "epi/i18n!epi/cms/nls/episerver.cms.components.project.command.removeprojectitem"
],
function (
    declare,
// Parent class
    _ProjectCommand,
    ContentActionSupport,
// Resources
    res
) {
    return declare([_ProjectCommand], {

        // category: [readonly] String
        //      A category which provides a hint about how the command could be displayed.
        category: "itemContext",

        // label: [public] String
        //      The action text of the command to be used in visual elements.
        label: res.label,

        modelPropertyToWatch: "selectedProjectItem",

        // store: [public] Store
        //      The store from which projects will be removed.
        store: null,

        _execute: function() {
            // summary:
            //      Executes this command assuming canExecute has been checked.
            // tags:
            //      protected
            this.model.removeSelectedProjectItem();
        },

        _setCanExecute: function() {
            // The command shouldn't be executable if a projectItem is not selected.

            var item = this.model.selectedProjectItem;
            this.set("canExecute", !!item && (item.status !== ContentActionSupport.versionStatus.PreviouslyPublished && item.status !== ContentActionSupport.versionStatus.Published));
        }
    });
});
