﻿define("epi/shell/command/builder/ButtonBuilder", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dijit/form/Button",
    "epi/shell/command/builder/_Builder",
    "../_CommandModelBindingMixin"
], function (declare, lang, Button, _Builder, _CommandModelBindingMixin) {

    // module:
    //		epi/shell/command/builder/ButtonBuilder
    // summary:
    //		Builds a button widget and connects events based on a command object.

    return declare([_Builder], {

        // _buttonClass: [private] class
        //      The class used for representing a button bound to a command
        _buttonClass: declare([Button, _CommandModelBindingMixin]),

        _create: function (command) {
            // summary:
            //		Creates a button widget from the given command.
            // tags:
            //		public

            var options = lang.mixin({ model: command }, this.settings);
            return new this._buttonClass(options);
        }
    });
});